#"/bin/bash
function pause(){
   read -p "$*"
}

PYREQUIRE="3.8.0"
if command -v python &> /dev/null
then
  # Python 3 is installed. Check version.
  PYVERSION="$(python3 -V | cut -d" " -f2)"
  echo "  Python found. Checking version ...";
    if [ "$(printf '%s\n' "$PYVERSION" "$PYREQUIRE" | sort -V | head -n1)" = "$PYREQUIRE" ]; then
      # Python version is greater or equal than 3.8.0. Pitanga Works.
      echo "    Python $PYVERSION found. Building the installation environment ...";
        python3 -m venv pitanga
        . pitanga/bin/activate
      echo "    Installing Pitanga packages ...";
        python3 -m pip install --upgrade pip
        python3 -m pip install -r requirements.txt
        echo
        echo "************************* Installation complete! *************************";
        echo
        pause 'Press [Enter] key to continue...'
        clear
        python pitanga.py -h
        sed 's/\\/\//g' quickstart.txt
    else
      # Python version is less than 3.8.0. Request user to upgrade Python.
      echo "    You have $(python3 -V) installed";
      echo "    Please, upgrade to version $PYREQUIRE or above.";
      pause 'Press [Enter] key to continue...'
    fi
else
  # Python 3 is NOT installed. Notify user.
  echo "  No Python installation found.";
  echo "  Please, install Python $PYREQUIRE or above.";
  pause 'Press [Enter] key to continue...'
fi
