module accum16(
    input LOW,

    input a00,
    input a01,
    input a02,
    input a03,
    input a04,
    input a05,
    input a06,
    input a07,

    input clk,
    input rst,
    input set,
    input cen,

    output segd0_a,
    output segd0_b,
    output segd0_c,
    output segd0_d,
    output segd0_e,
    output segd0_f,
    output segd0_g,

    output segd1_a,
    output segd1_b,
    output segd1_c,
    output segd1_d,
    output segd1_e,
    output segd1_f,
    output segd1_g,

    output segd2_a,
    output segd2_b,
    output segd2_c,
    output segd2_d,
    output segd2_e,
    output segd2_f,
    output segd2_g,

    output segd3_a,
    output segd3_b,
    output segd3_c,
    output segd3_d,
    output segd3_e,
    output segd3_f,
    output segd3_g,

    output cout
    );

    wire s00, s01, s02, s03, s04, s05, s06, s07,
         s08, s09, s10, s11, s12, s13, s14, s15;
    wire b00, b01, b02, b03, b04, b05, b06, b07,
         b08, b09, b10, b11, b12, b13, b14, b15;
    wire cout_sig;

    adder16 rca16(.cin(LOW),
                  .a00(a00), .a01(a01), .a02(a02), .a03(a03), .a04(a04), .a05(a05), .a06(a06), .a07(a07),
                  .a08(LOW), .a09(LOW), .a10(LOW), .a11(LOW), .a12(LOW), .a13(LOW), .a14(LOW), .a15(LOW),
                  .b00(b00), .b01(b01), .b02(b02), .b03(b03), .b04(b04), .b05(b05), .b06(b06), .b07(b07),
                  .b08(b08), .b09(b09), .b10(b10), .b11(b11), .b12(b12), .b13(b13), .b14(b14), .b15(b15),
                  .s00(s00), .s01(s01), .s02(s02), .s03(s03), .s04(s04), .s05(s05), .s06(s06), .s07(s07),
                  .s08(s08), .s09(s09), .s10(s10), .s11(s11), .s12(s12), .s13(s13), .s14(s14), .s15(s15),
                  .cout(cout_sig));

    reg16 reg16a(
        .d00(s00), .d01(s01), .d02(s02), .d03(s03), .d04(s04), .d05(s05), .d06(s06), .d07(s07),
        .d08(s08), .d09(s09), .d10(s10), .d11(s11), .d12(s12), .d13(s13), .d14(s14), .d15(s15),
        .clk(clk), .rst(rst), .set(set), .cen(cen),
        .q00(b00), .q01(b01), .q02(b02), .q03(b03), .q04(b04), .q05(b05), .q06(b06), .q07(b07),
        .q08(b08), .q09(b09), .q10(b10), .q11(b11), .q12(b12), .q13(b13), .q14(b14), .q15(b15)
    );

    DFFRSE dff_cout(.q(cout), .d(cout_sig), .clk(clk), .reset(rst), .set(set), .enable(cen));

    sevenseg ss0(.s0(b00), .s1(b01), .s2(b02), .s3(b03), .a(segd0_a), .b(segd0_b), .c(segd0_c), .d(segd0_d), .e(segd0_e), .f(segd0_f), .g(segd0_g));
    sevenseg ss1(.s0(b04), .s1(b05), .s2(b06), .s3(b07), .a(segd1_a), .b(segd1_b), .c(segd1_c), .d(segd1_d), .e(segd1_e), .f(segd1_f), .g(segd1_g));
    sevenseg ss2(.s0(b08), .s1(b09), .s2(b10), .s3(b11), .a(segd2_a), .b(segd2_b), .c(segd2_c), .d(segd2_d), .e(segd2_e), .f(segd2_f), .g(segd2_g));
    sevenseg ss3(.s0(b12), .s1(b13), .s2(b14), .s3(b15), .a(segd3_a), .b(segd3_b), .c(segd3_c), .d(segd3_d), .e(segd3_e), .f(segd3_f), .g(segd3_g));
endmodule