module sevenseg (
    input	s0,
    input   s1,
    input   s2,
    input   s3,
    output	a,
    output	b,
    output	c,
    output	d,
    output	e,
    output	f,
    output	g
);
// negative inputs
wire ns0, ns1, ns2, ns3;

not(ns0, s0);
not(ns1, s1);
not(ns2, s2);
not(ns3, s3);

// Logic A
wire [11:0] w_a;

and(w_a[0], s3, ns2);
and(w_a[1], w_a[0], ns1);
and(w_a[2], ns3, s2);
and(w_a[3], w_a[2], s0);
and(w_a[4], ns2, ns0);
and(w_a[5], ns3, s1);
and(w_a[6], s3, ns0);
and(w_a[7], s2, s1);
or(w_a[8], w_a[1], w_a[3]);
or(w_a[9], w_a[4], w_a[5]);
or(w_a[10], w_a[6], w_a[7]);
or(w_a[11], w_a[8], w_a[9]);
or(a, w_a[10], w_a[11]);

// Logic B
wire w1_b, w2_b, w3_b, w4_b, w5_b, w6_b, w7_b, w8_b, w9_b, w10_b, w11_b;

and(w1_b, ns3, ns1);
and(w2_b, w1_b, ns0);
and(w3_b, ns3, s1);
and(w4_b, w3_b, s0);
and(w5_b, s3, ns1);
and(w6_b, w5_b, s0);
and(w7_b, ns2, ns1);
and(w8_b, ns2, ns0);
or(w9_b, w2_b, w4_b);
or(w10_b, w6_b, w7_b);
or(w11_b, w9_b, w10_b);
or(b, w8_b, w11_b);

// Logic C
wire w1_c, w2_c, w3_c, w4_c, w5_c, w6_c, w7_c, w8_c;

and(w1_c, ns3, ns1);
and(w2_c, ns3, s0);
and(w3_c, ns1, s0);
and(w4_c, ns3, s2);
and(w5_c, s3, ns2);
or(w6_c, w1_c, w2_c);
or(w7_c, w3_c, w4_c);
or(w8_c, w6_c, w7_c);
or(c, w5_c, w8_c);

// Logic D
wire w1_d, w2_d, w3_d, w4_d, w5_d, w6_d, w7_d, w8_d, w9_d, w10_d, w11_d, w12_d;

and(w1_d, ns3, ns2);
and(w2_d, w1_d, ns0);
and(w3_d, ns2, s1);
and(w4_d, w3_d, s0);
and(w5_d, s2, ns1);
and(w6_d, w5_d, s0);
and(w7_d, s2, s1);
and(w8_d, w7_d, ns0);
and(w9_d, s3, ns1);
or(w10_d, w2_d, w4_d);
or(w11_d, w6_d, w8_d);
or(w12_d, w10_d, w11_d);
or(d, w12_d, w9_d);

// Logic E
wire w1_e, w2_e, w3_e, w4_e, w5_e, w6_e;

and(w1_e, s3, s1);
and(w2_e, s3, s2);
and(w3_e, s1, ns0);
and(w4_e, ns2, ns0);
or(w5_e, w1_e, w2_e);
or(w6_e, w3_e, w4_e);
or(e, w5_e, w6_e);

// Logic F
wire w1_f, w2_f, w3_f, w4_f, w5_f, w6_f, w7_f, w8_f, w9_f;

and(w1_f, ns3, s2);
and(w2_f, w1_f, ns1);
and(w3_f, ns1, ns0);
and(w4_f, s2, ns0);
and(w5_f, s3, ns2);
and(w6_f, s3, s1);
or(w7_f, w2_f, w3_f);
or(w8_f, w4_f, w5_f);
or(w9_f, w7_f, w8_f);
or(f, w6_f, w9_f);

// Logic G
wire w1_g, w2_g, w3_g, w4_g, w5_g, w6_g, w7_g, w8_g, w9_g;

and(w1_g, ns3, s2);
and(w2_g, w1_g, ns1);
and(w3_g, s3, ns2);
and(w4_g, s3, s0);
and(w5_g, ns2, s1);
and(w6_g, s1, ns0);
or(w7_g, w2_g, w3_g);
or(w8_g, w4_g, w5_g);
or(w9_g, w7_g, w8_g);
or(g, w6_g, w9_g);

endmodule
